--- asterisk-11.5.0.o/channels/chan_dahdi.c	2013-05-02 08:54:05.000000000 +0200
+++ asterisk-11.5.0/channels/chan_dahdi.c	2013-08-29 20:55:48.953053832 +0200
@@ -747,6 +747,10 @@
 	float rxgain;
 	/*! \brief Tx gain set by chan_dahdi.conf */
 	float txgain;
+	/*! \brief HW Rx gain */
+	float hwrxgain;
+	/*! \brief HW Tx gain */
+	float hwtxgain;
 
 	float txdrc; /*!< Dynamic Range Compression factor. a number between 1 and 6ish */
 	float rxdrc;
@@ -15693,7 +15697,8 @@
 			ast_cli(a->fd, "Default law: %s\n", tmp->law_default == DAHDI_LAW_MULAW ? "ulaw" : tmp->law_default == DAHDI_LAW_ALAW ? "alaw" : "unknown");
 			ast_cli(a->fd, "Fax Handled: %s\n", tmp->faxhandled ? "yes" : "no");
 			ast_cli(a->fd, "Pulse phone: %s\n", tmp->pulsedial ? "yes" : "no");
-			ast_cli(a->fd, "Gains (RX/TX): %.2f/%.2f\n", tmp->rxgain, tmp->txgain);
+			ast_cli(a->fd, "SW Gains (RX/TX): %.2f/%.2f\n", tmp->rxgain, tmp->txgain);
+			ast_cli(a->fd, "HW Gains (RX/TX): %.2f/%.2f\n", tmp->hwrxgain, tmp->hwtxgain);
 			ast_cli(a->fd, "Dynamic Range Compression (RX/TX): %.2f/%.2f\n", tmp->rxdrc, tmp->txdrc);
 			ast_cli(a->fd, "DND: %s\n", dahdi_dnd(tmp, -1) ? "yes" : "no");
 			ast_cli(a->fd, "Echo Cancellation:\n");
@@ -16012,6 +16017,10 @@
 		}
 		ast_cli(a->fd, "hardware %s gain set to %d (%.1f dB) on channel %d\n",
 			tx ? "tx" : "rx", gain, (float)gain/10.0, channel);
+		if (tx)
+			tmp->hwtxgain = gain / 10.0;
+		else
+			tmp->hwrxgain = gain / 10.0;
 		break;
 	}
 
@@ -16084,6 +16093,11 @@
 
 		ast_cli(a->fd, "software %s gain set to %.1f on channel %d\n",
 			tx ? "tx" : "rx", gain, channel);
+
+		if (tx)
+			tmp->txgain = gain;
+		else
+			tmp->rxgain = gain;
 		break;
 	}
 	ast_mutex_unlock(&iflock);
